﻿
using TenCrowns.GameCore;

namespace ExtendedInheritanceScreen
{
    class ExtendedInheritanceScreenCharacter : Character
    {
        public ExtendedInheritanceScreenCharacter() : base()
        {
            return;
        }

        public override void doTurn()
        {
            if (isDead())
            {
                return;
            }

            if (isCouncil())
            {
                increaseXP(infos().council(getCouncil()).miXP);
            }

            if (isCityGovernor())
            {
                increaseXP(cityGovernor().culture().miXP);
            }

            if ((game().getTurn() % game().getYearDivisions()) == (getID() % game().getYearDivisions()))
            {
                doTurnYear();
                // Dale Start
                if (isMale() && !(isRoyal() || isRoyalSpouse()) && hasPlayer())
                {
                    if (canHaveChildren())
                    {
                        foreach (int iSpouseID in getSpouses())
                        {
                            Character pLoopSpouse = game().character(iSpouseID);

                            if (pLoopSpouse.isAlive())
                            {
                                bool bPregnant = pLoopSpouse.hasTraitGiveBirth();

                                if (pLoopSpouse.canHaveChildren() || bPregnant)
                                {
                                    int iProb = 0;

                                    int iLivingChildren = countLivingChildren();

                                    if (iLivingChildren == 0)
                                    {
                                        iProb += 20;
                                    }
                                    else if (iLivingChildren == 1)
                                    {
                                        iProb += 10;
                                    }
                                    else
                                    {
                                        iProb += (10 / iLivingChildren);
                                    }

                                    iProb = infos().utils().modify(iProb, getTraitBirthModifier());
                                    iProb = infos().utils().modify(iProb, pLoopSpouse.getTraitBirthModifier());

                                    if (game().randomPercent(iProb) || bPregnant)
                                    {
                                        game().giveBirth(pLoopSpouse, this);
                                    }
                                }
                            }
                        }
                    }
                }

                if (hasPlayer() && !(player().hasCharacterMissionAny(this)))
                {
                    Character pFounder = player().founder();
                    if (pFounder != this)
                    {
                        if (!isRoyal() && !isRetired())
                        {
                            if (canMarry() && isFertileAge())
                            {
                                if (game().randomPercent(infos().Globals.NON_LEADER_MARRIAGE_PROB))
                                {
                                    doMarriage(false);
                                }
                            }
                        }
                    }
                }
                // Dale - END
            }

            testUpgrade(false);
        }
    }
}
